﻿Public Class Car
    'フィールド==========
    'Public _speed As Integer   'スピード情報
    Private _speed As Integer   'スピード情報(修正)

    'Public _gas As Double      'ガソリン情報
    Private _gas As Double      'ガソリン情報(修正)

    'プロパティ==========
    'スピード参照用
    Public ReadOnly Property Speed As Integer
        Get
            Return Me._speed
        End Get
    End Property

    'ガソリン参照・設定用
    Public Property Gas As Double
        Get
            Return Me._gas
        End Get
        Set(value As Double)
            '止まっている場合は指定したガソリン量を給油
            If Me._speed = 0 Then
                Me._gas += value
            End If
        End Set
    End Property

    'コンストラクタ===========
    Public Sub New()
        Me.New(20)
    End Sub

    Public Sub New(gas As Double)
        Me._speed = 0
        Me._gas = gas
    End Sub

    'メソッド==========
    '加速させるメソッド
    Public Overridable Sub SpeedUp(sp As Integer)
        'ガソリンを減らす
        Me._gas -= sp / 10.0
        If Me._gas < 0 Then   'ガソリンがマイナスになる場合
            'ガソリンを0に補正し、スピードを増やさない
            Me._gas = 0
        Else
            'スピードを増やす
            Me._speed += sp
        End If
    End Sub

    '減速させるメソッド
    Public Sub SpeedDown(sp As Integer)
        'スピードを減らす
        Me._speed -= sp
        If Me._speed < 0 Then     'スピードがマイナスになる場合
            'スピードを0に補正する
            Me._speed = 0
        End If
    End Sub

    '初期化を行うメソッド
    'Public Sub Init(gas As Double)
    '    Me._speed = 0
    '    Me._gas = gas
    'End Sub

    ''スピードを取得する
    'Public Function GetSpeed() As Integer
    '    Return Me._speed
    'End Function

    ''ガソリン量を取得する
    'Public Function GetGas() As Double
    '    Return Me._gas
    'End Function

    ''ガソリンを給油するメソッド
    'Public Sub SetGas()
    '    'オーバーロードしているメソッドを呼び出す
    '    Me.SetGas(20)
    'End Sub

    'Public Sub SetGas(gas As Double)
    '    '止まっている場合は指定したガソリン量を給油
    '    If Me._speed = 0 Then
    '        Me._gas += gas
    '    End If
    'End Sub

End Class
